/**
    * @license
    * Copyright 2022 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{Pose as t}from"@mediapipe/pose";import{Tensor as e,browser as i,util as n,tidy as r,add as o,mul as a,tensor2d as s,image as l,expandDims as u,cast as h,slice as c,squeeze as p,dispose as f,tensor1d as d,getBackend as m,engine as g,sub as y,square as v,minimum as x,backend as w,div as k,exp as b,concat as M,reshape as S,clipByValue as T,sigmoid as P,pad as F,mirrorPad as _,env as O,zeros as A,scalar as I,argMax as C}from"@tensorflow/tfjs-core";import{loadGraphModel as R}from"@tensorflow/tfjs-converter";var E=function(t,e){return(E=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i])})(t,e)};function z(t,e){function i(){this.constructor=t}E(t,e),t.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}var V=function(){return(V=Object.assign||function(t){for(var e,i=1,n=arguments.length;i<n;i++)for(var r in e=arguments[i])Object.prototype.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t}).apply(this,arguments)};function L(t,e,i,n){return new(i||(i=Promise))((function(r,o){function a(t){try{l(n.next(t))}catch(t){o(t)}}function s(t){try{l(n.throw(t))}catch(t){o(t)}}function l(t){var e;t.done?r(t.value):(e=t.value,e instanceof i?e:new i((function(t){t(e)}))).then(a,s)}l((n=n.apply(t,e||[])).next())}))}function B(t,e){var i,n,r,o,a={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(i)throw new TypeError("Generator is already executing.");for(;a;)try{if(i=1,n&&(r=2&o[0]?n.return:o[0]?n.throw||((r=n.return)&&r.call(n),0):n.next)&&!(r=r.call(n,o[1])).done)return r;switch(n=0,r&&(o=[2&o[0],r.value]),o[0]){case 0:case 1:r=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,n=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(r=a.trys,(r=r.length>0&&r[r.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!r||o[1]>r[0]&&o[1]<r[3])){a.label=o[1];break}if(6===o[0]&&a.label<r[1]){a.label=r[1],r=o;break}if(r&&a.label<r[2]){a.label=r[2],a.ops.push(o);break}r[2]&&a.ops.pop(),a.trys.pop();continue}o=e.call(t,a)}catch(t){o=[6,t],n=0}finally{i=r=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function N(){for(var t=0,e=0,i=arguments.length;e<i;e++)t+=arguments[e].length;var n=Array(t),r=0;for(e=0;e<i;e++)for(var o=arguments[e],a=0,s=o.length;a<s;a++,r++)n[r]=o[a];return n}var D=["nose","left_eye","right_eye","left_ear","right_ear","left_shoulder","right_shoulder","left_elbow","right_elbow","left_wrist","right_wrist","left_hip","right_hip","left_knee","right_knee","left_ankle","right_ankle"],K=["nose","left_eye_inner","left_eye","left_eye_outer","right_eye_inner","right_eye","right_eye_outer","left_ear","right_ear","mouth_left","mouth_right","left_shoulder","right_shoulder","left_elbow","right_elbow","left_wrist","right_wrist","left_pinky","right_pinky","left_index","right_index","left_thumb","right_thumb","left_hip","right_hip","left_knee","right_knee","left_ankle","right_ankle","left_heel","right_heel","left_foot_index","right_foot_index"],j={left:[1,2,3,7,9,11,13,15,17,19,21,23,25,27,29,31],right:[4,5,6,8,10,12,14,16,18,20,22,24,26,28,30,32],middle:[0]},H={left:[1,3,5,7,9,11,13,15],right:[2,4,6,8,10,12,14,16],middle:[0]},q=[[0,1],[0,2],[1,3],[2,4],[5,6],[5,7],[5,11],[6,8],[6,12],[7,9],[8,10],[11,12],[11,13],[12,14],[13,15],[14,16]],U=[[0,1],[0,4],[1,2],[2,3],[3,7],[4,5],[5,6],[6,8],[9,10],[11,12],[11,13],[11,23],[12,14],[14,16],[12,24],[13,15],[15,17],[16,18],[16,20],[15,17],[15,19],[15,21],[16,22],[17,19],[18,20],[23,25],[23,24],[24,26],[25,27],[26,28],[27,29],[28,30],[27,31],[28,32],[29,31],[30,32]];function X(t){return t instanceof SVGAnimatedLength?t.baseVal.value:t}function W(t){return L(this,void 0,void 0,(function(){var n,r;return B(this,(function(o){switch(o.label){case 0:return n=document.createElement("canvas"),t instanceof e?[4,i.toPixels(t,n)]:[3,2];case 1:return o.sent(),[3,3];case 2:n.width=X(t.width),n.height=X(t.height),r=n.getContext("2d"),t instanceof ImageData?r.putImageData(t,0,0):r.drawImage(t,0,0),o.label=3;case 3:return[2,n]}}))}))}function Y(t){return L(this,void 0,void 0,(function(){var n,r,o,a,s,l;return B(this,(function(u){switch(u.label){case 0:return t instanceof e?(n=t.shape.slice(0,2),r=n[0],o=n[1],a=ImageData.bind,[4,i.toPixels(t)]):[3,2];case 1:return[2,new(a.apply(ImageData,[void 0,u.sent(),o,r]))];case 2:return s=document.createElement("canvas"),l=s.getContext("2d"),s.width=X(t.width),s.height=X(t.height),l.drawImage(t,0,0),[2,l.getImageData(0,0,s.width,s.height)]}}))}))}function G(t){return L(this,void 0,void 0,(function(){var e,n;return B(this,(function(r){switch(r.label){case 0:return t instanceof SVGImageElement||t instanceof OffscreenCanvas?[4,W(t)]:[3,2];case 1:return n=r.sent(),[3,3];case 2:n=t,r.label=3;case 3:return e=n,[2,i.fromPixels(e,4)]}}))}))}function Q(t){if(t<0||t>=256)throw new Error("Mask value must be in range [0, 255] but got "+t);if(!Number.isInteger(t))throw new Error("Mask value must be an integer but got "+t)}var Z={runtime:"mediapipe",enableSmoothing:!0,enableSegmentation:!1,smoothSegmentation:!0,modelType:"full"};var $=function(){function t(t){this.mask=t}return t.prototype.toCanvasImageSource=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,this.mask]}))}))},t.prototype.toImageData=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,Y(this.mask)]}))}))},t.prototype.toTensor=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,G(this.mask)]}))}))},t.prototype.getUnderlyingType=function(){return"canvasimagesource"},t}();function J(t){return Q(t),"person"}var tt=function(){function n(e){var i,n=this;switch(this.width=0,this.height=0,this.selfieMode=!1,this.poseSolution=new t({locateFile:function(t,i){return e.solutionPath?e.solutionPath.replace(/\/+$/,"")+"/"+t:i+"/"+t}}),e.modelType){case"lite":i=0;break;case"heavy":i=2;break;case"full":default:i=1}this.poseSolution.setOptions({modelComplexity:i,smoothLandmarks:e.enableSmoothing,enableSegmentation:e.enableSegmentation,smoothSegmentation:e.smoothSegmentation,selfieMode:this.selfieMode}),this.poseSolution.onResults((function(t){if(n.height=t.image.height,n.width=t.image.width,null==t.poseLandmarks)n.poses=[];else{var e=n.translateOutput(t.poseLandmarks,t.poseWorldLandmarks);t.segmentationMask&&(e.segmentation={maskValueToLabel:J,mask:new $(t.segmentationMask)}),n.poses=[e]}}))}return n.prototype.translateOutput=function(t,e){var i=this,n={keypoints:t.map((function(t,e){return{x:t.x*i.width,y:t.y*i.height,z:t.z,score:t.visibility,name:K[e]}}))};return null!=e&&(n.keypoints3D=e.map((function(t,e){return{x:t.x,y:t.y,z:t.z,score:t.visibility,name:K[e]}}))),n},n.prototype.estimatePoses=function(t,n,r){return L(this,void 0,void 0,(function(){var o,a;return B(this,(function(s){switch(s.label){case 0:return n&&n.flipHorizontal&&n.flipHorizontal!==this.selfieMode&&(this.selfieMode=n.flipHorizontal,this.poseSolution.setOptions({selfieMode:this.selfieMode})),t instanceof e?(a=ImageData.bind,[4,i.toPixels(t)]):[3,2];case 1:return o=new(a.apply(ImageData,[void 0,s.sent(),t.shape[1],t.shape[0]])),[3,3];case 2:o=t,s.label=3;case 3:return t=o,[4,this.poseSolution.send({image:t},r)];case 4:return s.sent(),[2,this.poses]}}))}))},n.prototype.dispose=function(){this.poseSolution.close()},n.prototype.reset=function(){this.poseSolution.reset()},n.prototype.initialize=function(){return this.poseSolution.initialize()},n}();function et(t){return L(this,void 0,void 0,(function(){var e,i;return B(this,(function(n){switch(n.label){case 0:return e=function(t){if(null==t)return V({},Z);var e=V({},t);return e.runtime="mediapipe",null==e.enableSegmentation&&(e.enableSegmentation=Z.enableSegmentation),null==e.enableSmoothing&&(e.enableSmoothing=Z.enableSmoothing),null==e.smoothSegmentation&&(e.smoothSegmentation=Z.smoothSegmentation),null==e.modelType&&(e.modelType=Z.modelType),e}(t),[4,(i=new tt(e)).initialize()];case 1:return n.sent(),[2,i]}}))}))}function it(t){return t instanceof e?{height:t.shape[0],width:t.shape[1]}:{height:t.height,width:t.width}}function nt(t){return t-2*Math.PI*Math.floor((t+Math.PI)/(2*Math.PI))}function rt(t){return t instanceof e?t:i.fromPixels(t)}function ot(t,e,i){return at(i,"inputResolution"),[1/i.width*t[0][0]*e.width,1/i.height*t[0][1]*e.width,t[0][3]*e.width,1/i.width*t[1][0]*e.height,1/i.height*t[1][1]*e.height,t[1][3]*e.height,0,0]}function at(t,e){n.assert(0!==t.width,(function(){return e+" width cannot be 0."})),n.assert(0!==t.height,(function(){return e+" height cannot be 0."}))}function st(t,e,i){var n=i.rotationVectorStartKeypointIndex,r=i.rotationVectorEndKeypointIndex,o=t.locationData,a=o.relativeKeypoints[n].x*e.width,s=o.relativeKeypoints[n].y*e.height,l=o.relativeKeypoints[r].x*e.width,u=o.relativeKeypoints[r].y*e.height,h=2*Math.sqrt((l-a)*(l-a)+(u-s)*(u-s)),c=function(t,e,i){var n,r=t.locationData,o=i.rotationVectorStartKeypointIndex,a=i.rotationVectorEndKeypointIndex;n=i.rotationVectorTargetAngle?i.rotationVectorTargetAngle:Math.PI*i.rotationVectorTargetAngleDegree/180;var s=r.relativeKeypoints[o].x*e.width,l=r.relativeKeypoints[o].y*e.height,u=r.relativeKeypoints[a].x*e.width,h=r.relativeKeypoints[a].y*e.height;return nt(n-Math.atan2(-(h-l),u-s))}(t,e,i);return{xCenter:a/e.width,yCenter:s/e.height,width:h/e.width,height:h/e.height,rotation:c}}function lt(t){if(16!==t.length)throw new Error("Array length must be 16 but got "+t.length);return[[t[0],t[1],t[2],t[3]],[t[4],t[5],t[6],t[7]],[t[8],t[9],t[10],t[11]],[t[12],t[13],t[14],t[15]]]}function ut(t,e,i,n,r,o,a){return t[e][r]*(t[i][o]*t[n][a]-t[i][a]*t[n][o])}function ht(t,e,i){var n=(e+1)%4,r=(e+2)%4,o=(e+3)%4,a=(i+1)%4,s=(i+2)%4,l=(i+3)%4;return ut(t,n,r,o,a,s,l)+ut(t,r,o,n,a,s,l)+ut(t,o,n,r,a,s,l)}function ct(t,e,i){void 0===i&&(i={ignoreRotation:!1});for(var n=[],r=0,o=t;r<o.length;r++){var a=o[r],s=a.x-.5,l=a.y-.5,u=i.ignoreRotation?0:e.rotation,h=Math.cos(u)*s-Math.sin(u)*l,c=Math.sin(u)*s+Math.cos(u)*l;h=h*e.width+e.xCenter,c=c*e.height+e.yCenter;var p=a.z*e.width,f=V({},a);f.x=h,f.y=c,f.z=p,n.push(f)}return n}function pt(t,e){var i=function(t,e,i,n){var r=e-t,o=n-i;if(0===r)throw new Error("Original min and max are both "+t+", range cannot be 0.");var a=o/r;return{scale:a,offset:i-t*a}}(0,255,e[0],e[1]);return r((function(){return o(a(t,i.scale),i.offset)}))}function ft(t,e,i){var n,o,a,c,p,f,d,m,g,y,v,x,w,k,b=e.outputTensorSize,M=e.keepAspectRatio,S=e.borderMode,T=e.outputTensorFloatRange,P=it(t),F=function(t,e){return e?{xCenter:e.xCenter*t.width,yCenter:e.yCenter*t.height,width:e.width*t.width,height:e.height*t.height,rotation:e.rotation}:{xCenter:.5*t.width,yCenter:.5*t.height,width:t.width,height:t.height,rotation:0}}(P,i),_=function(t,e,i){if(void 0===i&&(i=!1),!i)return{top:0,left:0,right:0,bottom:0};var n=e.height,r=e.width;at(e,"targetSize"),at(t,"roi");var o,a,s=n/r,l=t.height/t.width,u=0,h=0;return s>l?(o=t.width,a=t.width*s,h=(1-l/s)/2):(o=t.height/s,a=t.height,u=(1-s/l)/2),t.width=o,t.height=a,{top:h,left:u,right:u,bottom:h}}(F,b,M),O=(n=F,o=P.width,a=P.height,c=!1,p=n.width,f=n.height,d=c?-1:1,m=Math.cos(n.rotation),g=Math.sin(n.rotation),y=n.xCenter,v=n.yCenter,x=1/o,w=1/a,(k=new Array(16))[0]=p*m*d*x,k[1]=-f*g*x,k[2]=0,k[3]=(-.5*p*m*d+.5*f*g+y)*x,k[4]=p*g*d*w,k[5]=f*m*w,k[6]=0,k[7]=(-.5*f*m-.5*p*g*d+v)*w,k[8]=0,k[9]=0,k[10]=p*x,k[11]=0,k[12]=0,k[13]=0,k[14]=0,k[15]=1,lt(k));return{imageTensor:r((function(){var e=rt(t),i=s(ot(O,P,b),[1,8]),n="zero"===S?"constant":"nearest",r=l.transform(u(h(e,"float32")),i,"bilinear",n,0,[b.height,b.width]);return null!=T?pt(r,T):r})),padding:_,transformationMatrix:O}}function dt(t,e,i,n){return 1===n?.5*(t+e):t+(e-t)*i/(n-1)}function mt(t){return r((function(){var e=function(t){return r((function(){return[c(t,[0,0,0],[1,-1,1]),c(t,[0,0,1],[1,-1,-1])]}))}(t),i=e[0],n=e[1];return{boxes:p(n),logits:p(i)}}))}function gt(t){return null!=t&&null!=t.currentTime}function yt(t){for(var e={locationData:{relativeKeypoints:[]}},i=Number.MAX_SAFE_INTEGER,n=Number.MIN_SAFE_INTEGER,r=Number.MAX_SAFE_INTEGER,o=Number.MIN_SAFE_INTEGER,a=0;a<t.length;++a){var s=t[a];i=Math.min(i,s.x),n=Math.max(n,s.x),r=Math.min(r,s.y),o=Math.max(o,s.y),e.locationData.relativeKeypoints.push({x:s.x,y:s.y})}return e.locationData.relativeBoundingBox={xMin:i,yMin:r,xMax:n,yMax:o,width:n-i,height:o-r},e}function vt(t,e,i,n){return L(this,void 0,void 0,(function(){var n,r,o,a,u;return B(this,(function(h){switch(h.label){case 0:return t.sort((function(t,e){return Math.max.apply(Math,e.score)-Math.max.apply(Math,t.score)})),n=s(t.map((function(t){return[t.locationData.relativeBoundingBox.yMin,t.locationData.relativeBoundingBox.xMin,t.locationData.relativeBoundingBox.yMax,t.locationData.relativeBoundingBox.xMax]}))),r=d(t.map((function(t){return t.score[0]}))),[4,l.nonMaxSuppressionAsync(n,r,e,i)];case 1:return[4,(o=h.sent()).array()];case 2:return a=h.sent(),u=t.filter((function(t,e){return a.indexOf(e)>-1})),f([n,r,o]),[2,u]}}))}))}function xt(t,e){return t.map((function(t){var i=V(V({},t),{x:t.x*e.width,y:t.y*e.height});return null!=t.z&&(i.z=t.z*e.width),i}))}function wt(t,e,i){return L(this,void 0,void 0,(function(){var n,r,o,a,s,l,u,h,c,f,d,m,g,y,v,x,w,k,b,M,S,T,P,F;return B(this,(function(_){switch(_.label){case 0:if(n=p(e,[0]),r=n.shape,o=r[0],a=r[1],s=r[2],t.length!==s)throw new Error("Expected heatmap to have same number of channels as the number of landmarks. But got landmarks length: "+t.length+", heatmap length: "+s);return l=[],[4,n.buffer()];case 1:for(u=_.sent(),h=0;h<t.length;h++)if(c=t[h],f=V({},c),l.push(f),d=Math.trunc(f.x*a),m=Math.trunc(f.y*o),!(d<0||d>=a||m<0||d>=o)){for(g=Math.trunc((i.kernelSize-1)/2),y=Math.max(0,d-g),v=Math.min(a,d+g+1),x=Math.max(0,m-g),w=Math.min(o,m+g+1),k=0,b=0,M=0,S=0,T=x;T<w;++T)for(P=y;P<v;++P)F=u.get(T,P,h),k+=F,S=Math.max(S,F),b+=P*F,M+=T*F;S>=i.minConfidenceToRefine&&k>0&&(f.x=b/a/k,f.y=M/o/k)}return n.dispose(),[2,l]}}))}))}function kt(t,e){var i=e.left,n=e.top,r=e.left+e.right,o=e.top+e.bottom;return t.map((function(t){return V(V({},t),{x:(t.x-i)/(1-r),y:(t.y-n)/(1-o),z:t.z/(1-r)})}))}function bt(t,e,i){return"webgl"===m()?function(t,e,i){var n=i.combineWithPreviousRatio.toFixed(2),o={variableNames:["prevMask","newMask"],outputShape:t.shape,userCode:"\n  void main() {\n      ivec2 coords = getOutputCoords();\n      int height = coords[0];\n      int width = coords[1];\n\n      float prevMaskValue = getPrevMask(height, width);\n      float newMaskValue = getNewMask(height, width);\n\n      /*\n      * Assume p := newMaskValue\n      * H(p) := 1 + (p * log(p) + (1-p) * log(1-p)) / log(2)\n      * uncertainty alpha(p) =\n      *   Clamp(1 - (1 - H(p)) * (1 - H(p)), 0, 1) [squaring the\n      * uncertainty]\n      *\n      * The following polynomial approximates uncertainty alpha as a\n      * function of (p + 0.5):\n      */\n      const float c1 = 5.68842;\n      const float c2 = -0.748699;\n      const float c3 = -57.8051;\n      const float c4 = 291.309;\n      const float c5 = -624.717;\n      float t = newMaskValue - 0.5;\n      float x = t * t;\n\n      float uncertainty =\n        1.0 - min(1.0, x * (c1 + x * (c2 + x * (c3 + x * (c4 + x * c5)))));\n\n      float outputValue = newMaskValue + (prevMaskValue - newMaskValue) *\n                             (uncertainty * "+n+");\n\n      setOutput(outputValue);\n    }\n"},a=w();return r((function(){var i=a.compileAndRun(o,[t,e]);return g().makeTensorFromDataId(i.dataId,i.shape,i.dtype)}))}(t,e,i):r((function(){var n=y(e,.5),r=v(n),s=y(1,x(1,a(r,o(5.68842,a(r,o(-.748699,a(r,o(-57.8051,a(r,o(291.309,a(r,-624.717)))))))))));return o(e,a(y(t,e),a(s,i.combineWithPreviousRatio)))}))}function Mt(t,e,i){return L(this,void 0,void 0,(function(){var n,s,l,u,h;return B(this,(function(d){switch(d.label){case 0:return n=t[0],s=t[1],l=function(t,e,i){return r((function(){var n,r,s,l;i.reverseOutputOrder?(r=p(c(t,[0,i.boxCoordOffset+0],[-1,1])),n=p(c(t,[0,i.boxCoordOffset+1],[-1,1])),l=p(c(t,[0,i.boxCoordOffset+2],[-1,1])),s=p(c(t,[0,i.boxCoordOffset+3],[-1,1]))):(n=p(c(t,[0,i.boxCoordOffset+0],[-1,1])),r=p(c(t,[0,i.boxCoordOffset+1],[-1,1])),s=p(c(t,[0,i.boxCoordOffset+2],[-1,1])),l=p(c(t,[0,i.boxCoordOffset+3],[-1,1]))),r=o(a(k(r,i.xScale),e.w),e.x),n=o(a(k(n,i.yScale),e.h),e.y),i.applyExponentialOnBoxSize?(s=a(b(k(s,i.hScale)),e.h),l=a(b(k(l,i.wScale)),e.w)):(s=a(k(s,i.hScale),e.h),l=a(k(l,i.wScale),e.h));var u=y(n,k(s,2)),h=y(r,k(l,2)),f=o(n,k(s,2)),d=o(r,k(l,2)),m=M([S(u,[i.numBoxes,1]),S(h,[i.numBoxes,1]),S(f,[i.numBoxes,1]),S(d,[i.numBoxes,1])],1);if(i.numKeypoints)for(var g=0;g<i.numKeypoints;++g){var v=i.keypointCoordOffset+g*i.numValuesPerKeypoint,x=void 0,w=void 0;i.reverseOutputOrder?(x=p(c(t,[0,v],[-1,1])),w=p(c(t,[0,v+1],[-1,1]))):(w=p(c(t,[0,v],[-1,1])),x=p(c(t,[0,v+1],[-1,1])));var T=o(a(k(x,i.xScale),e.w),e.x),P=o(a(k(w,i.yScale),e.h),e.y);m=M([m,S(T,[i.numBoxes,1]),S(P,[i.numBoxes,1])],1)}return m}))}(s,e,i),u=r((function(){var t=n;return i.sigmoidScore?(null!=i.scoreClippingThresh&&(t=T(n,-i.scoreClippingThresh,i.scoreClippingThresh)),t=P(t)):t})),[4,St(l,u,i)];case 1:return h=d.sent(),f([l,u]),[2,h]}}))}))}function St(t,e,i){return L(this,void 0,void 0,(function(){var n,r,o,a,s,l,u,h,c,p,f,d;return B(this,(function(m){switch(m.label){case 0:return n=[],[4,t.data()];case 1:return r=m.sent(),[4,e.data()];case 2:for(o=m.sent(),a=0;a<i.numBoxes;++a)if(!(null!=i.minScoreThresh&&o[a]<i.minScoreThresh||(s=a*i.numCoords,l=Tt(r[s+0],r[s+1],r[s+2],r[s+3],o[a],i.flipVertically,a),(u=l.locationData.relativeBoundingBox).width<0||u.height<0))){if(i.numKeypoints>0)for((h=l.locationData).relativeKeypoints=[],c=i.numKeypoints*i.numValuesPerKeypoint,p=0;p<c;p+=i.numValuesPerKeypoint)f=s+i.keypointCoordOffset+p,d={x:r[f+0],y:i.flipVertically?1-r[f+1]:r[f+1]},h.relativeKeypoints.push(d);n.push(l)}return[2,n]}}))}))}function Tt(t,e,i,n,r,o,a){return{score:[r],ind:a,locationData:{relativeBoundingBox:{xMin:e,yMin:o?1-i:t,xMax:n,yMax:o?1-t:i,width:n-e,height:i-t}}}}function Pt(t,e){return"none"===t?e:function(t){return 1/(1+Math.exp(-t))}(e)}function Ft(t,e,i,n){return L(this,void 0,void 0,(function(){var r,o,a,s,l,u,h,c;return B(this,(function(p){switch(p.label){case 0:return i=i||e.flipHorizontally||!1,n=n||e.flipVertically||!1,r=t.size,o=r/e.numLandmarks,[4,t.data()];case 1:for(a=p.sent(),s=[],l=0;l<e.numLandmarks;++l)u=l*o,(c={x:0,y:0}).x=i?e.inputImageWidth-a[u]:a[u],o>1&&(c.y=n?e.inputImageHeight-a[u+1]:a[u+1]),o>2&&(c.z=a[u+2]),o>3&&(c.score=Pt(e.visibilityActivation,a[u+3])),s.push(c);for(h=0;h<s.length;++h)(c=s[h]).x=c.x/e.inputImageWidth,c.y=c.y/e.inputImageHeight,c.z=c.z/e.inputImageWidth/(e.normalizeZ||1);return[2,s]}}))}))}function _t(t,e,i){var n=t.width,r=t.height,o=t.rotation;if(null==i.rotation&&null==i.rotationDegree||(o=function(t,e){null!=e.rotation?t+=e.rotation:null!=e.rotationDegree&&(t+=Math.PI*e.rotationDegree/180);return nt(t)}(o,i)),0===o)t.xCenter=t.xCenter+n*i.shiftX,t.yCenter=t.yCenter+r*i.shiftY;else{var a=(e.width*n*i.shiftX*Math.cos(o)-e.height*r*i.shiftY*Math.sin(o))/e.width,s=(e.width*n*i.shiftX*Math.sin(o)+e.height*r*i.shiftY*Math.cos(o))/e.height;t.xCenter=t.xCenter+a,t.yCenter=t.yCenter+s}if(i.squareLong){var l=Math.max(n*e.width,r*e.height);n=l/e.width,r=l/e.height}else if(i.squareShort){var u=Math.min(n*e.width,r*e.height);n=u/e.width,r=u/e.height}return t.width=n*i.scaleX,t.height=r*i.scaleY,t}function Ot(t,e){return t.map((function(t){var i=V(V({},t),{x:t.x/e.width,y:t.y/e.height});return null!=t.z&&(t.z=t.z/e.width),i}))}var At=function(){function t(t){this.alpha=t,this.initialized=!1}return t.prototype.apply=function(t,e){var i;return this.initialized?i=null==e?this.storedValue+this.alpha*(t-this.storedValue):this.storedValue+this.alpha*e*Math.asinh((t-this.storedValue)/e):(i=t,this.initialized=!0),this.rawValue=t,this.storedValue=i,i},t.prototype.applyWithAlpha=function(t,e,i){return this.alpha=e,this.apply(t,i)},t.prototype.hasLastRawValue=function(){return this.initialized},t.prototype.lastRawValue=function(){return this.rawValue},t.prototype.reset=function(){this.initialized=!1},t}(),It=function(){function t(t){this.frequency=t.frequency,this.minCutOff=t.minCutOff,this.beta=t.beta,this.thresholdCutOff=t.thresholdCutOff,this.thresholdBeta=t.thresholdBeta,this.derivateCutOff=t.derivateCutOff,this.x=new At(this.getAlpha(this.minCutOff)),this.dx=new At(this.getAlpha(this.derivateCutOff)),this.lastTimestamp=0}return t.prototype.apply=function(t,e,i){if(null==t)return t;var n=Math.trunc(e);if(this.lastTimestamp>=n)return t;0!==this.lastTimestamp&&0!==n&&(this.frequency=1/(1e-6*(n-this.lastTimestamp))),this.lastTimestamp=n;var r=this.x.hasLastRawValue()?(t-this.x.lastRawValue())*i*this.frequency:0,o=this.dx.applyWithAlpha(r,this.getAlpha(this.derivateCutOff)),a=this.minCutOff+this.beta*Math.abs(o),s=null!=this.thresholdCutOff?this.thresholdCutOff+this.thresholdBeta*Math.abs(o):null;return this.x.applyWithAlpha(t,this.getAlpha(a),s)},t.prototype.getAlpha=function(t){return 1/(1+this.frequency/(2*Math.PI*t))},t}(),Ct=function(){function t(t){this.config=t}return t.prototype.apply=function(t,e,i){var n=this;if(null==t)return this.reset(),null;this.initializeFiltersIfEmpty(t);var r=1;if(!this.config.disableValueScaling){if(i<this.config.minAllowedObjectScale)return N(t);r=1/i}return t.map((function(t,i){var o=V(V({},t),{x:n.xFilters[i].apply(t.x,e,r),y:n.yFilters[i].apply(t.y,e,r)});return null!=t.z&&(o.z=n.zFilters[i].apply(t.z,e,r)),o}))},t.prototype.reset=function(){this.xFilters=null,this.yFilters=null,this.zFilters=null},t.prototype.initializeFiltersIfEmpty=function(t){var e=this;null!=this.xFilters&&this.xFilters.length===t.length||(this.xFilters=t.map((function(t){return new It(e.config)})),this.yFilters=t.map((function(t){return new It(e.config)})),this.zFilters=t.map((function(t){return new It(e.config)})))},t}(),Rt=function(){function t(t){this.config=t,this.window=[],this.lowPassFilter=new At(1),this.lastValue=0,this.lastValueScale=1,this.lastTimestamp=-1}return t.prototype.apply=function(t,e,i){if(null==t)return t;var n,r=Math.trunc(e);if(this.lastTimestamp>=r)return t;if(-1===this.lastTimestamp)n=1;else{for(var o=t*i-this.lastValue*this.lastValueScale,a=r-this.lastTimestamp,s=o,l=a,u=(1+this.window.length)*(1e6/30),h=0,c=this.window;h<c.length;h++){var p=c[h];if(l+p.duration>u)break;s+=p.distance,l+=p.duration}var f=s/(1e-6*l);n=1-1/(1+this.config.velocityScale*Math.abs(f)),this.window.unshift({distance:o,duration:a}),this.window.length>this.config.windowSize&&this.window.pop()}return this.lastValue=t,this.lastValueScale=i,this.lastTimestamp=r,this.lowPassFilter.applyWithAlpha(t,n)},t}(),Et=function(){function t(t){this.config=t}return t.prototype.apply=function(t,e,i){var n=this;if(null==t)return this.reset(),null;var r=1;if(!this.config.disableValueScaling){if(i<this.config.minAllowedObjectScale)return N(t);r=1/i}return this.initializeFiltersIfEmpty(t),t.map((function(t,i){var o=V(V({},t),{x:n.xFilters[i].apply(t.x,e,r),y:n.yFilters[i].apply(t.y,e,r)});return null!=t.z&&(o.z=n.zFilters[i].apply(t.z,e,r)),o}))},t.prototype.reset=function(){this.xFilters=null,this.yFilters=null,this.zFilters=null},t.prototype.initializeFiltersIfEmpty=function(t){var e=this;null!=this.xFilters&&this.xFilters.length===t.length||(this.xFilters=t.map((function(t){return new Rt(e.config)})),this.yFilters=t.map((function(t){return new Rt(e.config)})),this.zFilters=t.map((function(t){return new Rt(e.config)})))},t}(),zt=function(){function t(t){if(null!=t.velocityFilter)this.keypointsFilter=new Et(t.velocityFilter);else{if(null==t.oneEuroFilter)throw new Error("Either configure velocityFilter or oneEuroFilter, but got "+t+".");this.keypointsFilter=new Ct(t.oneEuroFilter)}}return t.prototype.apply=function(t,e,i,n,r){if(void 0===n&&(n=!1),null==t)return this.keypointsFilter.reset(),null;var o=null!=r?function(t,e){return(t.width*e.width+t.height*e.height)/2}(r,i):1,a=n?xt(t,i):t,s=this.keypointsFilter.apply(a,e,o);return n?Ot(s,i):s},t}(),Vt=function(){function t(t){this.alpha=t.alpha}return t.prototype.apply=function(t){var e=this;if(null==t)return this.visibilityFilters=null,null;null!=this.visibilityFilters&&this.visibilityFilters.length===t.length||(this.visibilityFilters=t.map((function(t){return new At(e.alpha)})));for(var i=[],n=0;n<t.length;++n){var r=t[n],o=V({},r);o.score=this.visibilityFilters[n].apply(r.score),i.push(o)}return i},t}(),Lt={reduceBoxesInLowestlayer:!1,interpolatedScaleAspectRatio:1,featureMapHeight:[],featureMapWidth:[],numLayers:5,minScale:.1484375,maxScale:.75,inputSizeHeight:224,inputSizeWidth:224,anchorOffsetX:.5,anchorOffsetY:.5,strides:[8,16,32,32,32],aspectRatios:[1],fixedAnchorSize:!0},Bt={runtime:"tfjs",modelType:"full",enableSmoothing:!0,enableSegmentation:!1,smoothSegmentation:!0,detectorModelUrl:"https://tfhub.dev/mediapipe/tfjs-model/blazepose_3d/detector/1",landmarkModelUrl:"https://tfhub.dev/mediapipe/tfjs-model/blazepose_3d/landmark/full/2"},Nt={maxPoses:1,flipHorizontal:!1},Dt={applyExponentialOnBoxSize:!1,flipVertically:!1,ignoreClasses:[],numClasses:1,numBoxes:2254,numCoords:12,boxCoordOffset:0,keypointCoordOffset:4,numKeypoints:4,numValuesPerKeypoint:2,sigmoidScore:!0,scoreClippingThresh:100,reverseOutputOrder:!0,xScale:224,yScale:224,hScale:224,wScale:224,minScoreThresh:.5},Kt=.3,jt={shiftX:0,shiftY:0,scaleX:1.25,scaleY:1.25,squareLong:!0},Ht={outputTensorSize:{width:224,height:224},keepAspectRatio:!0,outputTensorFloatRange:[-1,1],borderMode:"zero"},qt={outputTensorSize:{width:256,height:256},keepAspectRatio:!0,outputTensorFloatRange:[0,1],borderMode:"zero"},Ut={numLandmarks:39,inputImageWidth:256,inputImageHeight:256,visibilityActivation:"sigmoid",flipHorizontally:!1,flipVertically:!1},Xt={numLandmarks:39,inputImageWidth:1,inputImageHeight:1,visibilityActivation:"sigmoid",flipHorizontally:!1,flipVertically:!1},Wt={kernelSize:7,minConfidenceToRefine:.5},Yt={alpha:.1},Gt={oneEuroFilter:{frequency:30,minCutOff:.05,beta:80,derivateCutOff:1,minAllowedObjectScale:1e-6}},Qt={oneEuroFilter:{frequency:30,minCutOff:.01,beta:10,derivateCutOff:1,minAllowedObjectScale:1e-6}},Zt={oneEuroFilter:{frequency:30,minCutOff:.1,beta:40,derivateCutOff:1,minAllowedObjectScale:1e-6,disableValueScaling:!0}},$t={activation:"none"},Jt={combineWithPreviousRatio:.7};var te=function(){function t(t){this.mask=t}return t.prototype.toCanvasImageSource=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,W(this.mask)]}))}))},t.prototype.toImageData=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,Y(this.mask)]}))}))},t.prototype.toTensor=function(){return L(this,void 0,void 0,(function(){return B(this,(function(t){return[2,this.mask]}))}))},t.prototype.getUnderlyingType=function(){return"tensor"},t}();function ee(t){return Q(t),"person"}var ie=function(){function t(t,e,i,n,r,o){this.detectorModel=t,this.landmarkModel=e,this.enableSmoothing=i,this.enableSegmentation=n,this.smoothSegmentation=r,this.modelType=o,this.regionOfInterest=null,this.prevFilteredSegmentationMask=null,this.anchors=function(t){null==t.reduceBoxesInLowestLayer&&(t.reduceBoxesInLowestLayer=!1),null==t.interpolatedScaleAspectRatio&&(t.interpolatedScaleAspectRatio=1),null==t.fixedAnchorSize&&(t.fixedAnchorSize=!1);for(var e=[],i=0;i<t.numLayers;){for(var n=[],r=[],o=[],a=[],s=i;s<t.strides.length&&t.strides[s]===t.strides[i];){var l=dt(t.minScale,t.maxScale,s,t.strides.length);if(0===s&&t.reduceBoxesInLowestLayer)o.push(1),o.push(2),o.push(.5),a.push(.1),a.push(l),a.push(l);else{for(var u=0;u<t.aspectRatios.length;++u)o.push(t.aspectRatios[u]),a.push(l);if(t.interpolatedScaleAspectRatio>0){var h=s===t.strides.length-1?1:dt(t.minScale,t.maxScale,s+1,t.strides.length);a.push(Math.sqrt(l*h)),o.push(t.interpolatedScaleAspectRatio)}}s++}for(var c=0;c<o.length;++c){var p=Math.sqrt(o[c]);n.push(a[c]/p),r.push(a[c]*p)}var f=0,d=0;if(t.featureMapHeight.length>0)f=t.featureMapHeight[i],d=t.featureMapWidth[i];else{var m=t.strides[i];f=Math.ceil(t.inputSizeHeight/m),d=Math.ceil(t.inputSizeWidth/m)}for(var g=0;g<f;++g)for(var y=0;y<d;++y)for(var v=0;v<n.length;++v){var x={xCenter:(y+t.anchorOffsetX)/d,yCenter:(g+t.anchorOffsetY)/f,width:0,height:0};t.fixedAnchorSize?(x.width=1,x.height=1):(x.width=r[v],x.height=n[v]),e.push(x)}i=s}return e}(Lt);var a=d(this.anchors.map((function(t){return t.width}))),l=d(this.anchors.map((function(t){return t.height}))),u=d(this.anchors.map((function(t){return t.xCenter}))),h=d(this.anchors.map((function(t){return t.yCenter})));this.anchorTensor={x:u,y:h,w:a,h:l},this.prevFilteredSegmentationMask=this.enableSegmentation?s([],[0,0]):null}return t.prototype.estimatePoses=function(t,e,i){return L(this,void 0,void 0,(function(){var n,o,a,s,l,c,p,d,m,g,y,v,x,w,k,b,M,S,T,P,O,A,I;return B(this,(function(C){switch(C.label){case 0:return n=function(t){var e;if(null==(e=null==t?Nt:V({},t)).maxPoses&&(e.maxPoses=1),e.maxPoses<=0)throw new Error("Invalid maxPoses "+e.maxPoses+". Should be > 0.");if(e.maxPoses>1)throw new Error("Multi-pose detection is not implemented yet. Please set maxPoses to 1.");return e}(e),null==t?(this.reset(),[2,[]]):(this.maxPoses=n.maxPoses,this.timestamp=null!=i?1e3*i:gt(t)?1e6*t.currentTime:null,o=it(t),a=r((function(){return h(rt(t),"float32")})),null!=(s=this.regionOfInterest)?[3,2]:[4,this.detectPose(a)]);case 1:if(0===(l=C.sent()).length)return this.reset(),a.dispose(),[2,[]];c=l[0],s=this.poseDetectionToRoi(c,o),C.label=2;case 2:return[4,this.poseLandmarksByRoi(s,a)];case 3:return p=C.sent(),a.dispose(),null==p?(this.reset(),[2,[]]):(d=p.landmarks,m=p.auxiliaryLandmarks,g=p.poseScore,y=p.worldLandmarks,v=p.segmentationMask,x=this.poseLandmarkFiltering(d,m,y,o),w=x.actualLandmarksFiltered,k=x.auxiliaryLandmarksFiltered,b=x.actualWorldLandmarksFiltered,M=this.poseLandmarksToRoi(k,o),this.regionOfInterest=M,S=this.smoothSegmentation&&null!=v?this.poseSegmentationFiltering(v):v,null!=(T=null!=w?xt(w,o):null)&&T.forEach((function(t,e){t.name=K[e]})),null!=(P=b)&&P.forEach((function(t,e){t.name=K[e]})),O={score:g,keypoints:T,keypoints3D:P},null!==S&&(A=r((function(){var t=u(S,2),e=F(t,[[0,0],[0,0],[0,1]]);return _(e,[[0,0],[0,0],[0,2]],"symmetric")})),this.smoothSegmentation||f(S),I={maskValueToLabel:ee,mask:new te(A)},O.segmentation=I),[2,[O]])}}))}))},t.prototype.poseSegmentationFiltering=function(t){var e=this.prevFilteredSegmentationMask;return 0===e.size?this.prevFilteredSegmentationMask=t:(this.prevFilteredSegmentationMask=bt(e,t,Jt),f(t)),f(e),this.prevFilteredSegmentationMask},t.prototype.dispose=function(){this.detectorModel.dispose(),this.landmarkModel.dispose(),f([this.anchorTensor.x,this.anchorTensor.y,this.anchorTensor.w,this.anchorTensor.h,this.prevFilteredSegmentationMask])},t.prototype.reset=function(){this.regionOfInterest=null,this.enableSegmentation&&(f(this.prevFilteredSegmentationMask),this.prevFilteredSegmentationMask=s([],[0,0])),this.visibilitySmoothingFilterActual=null,this.visibilitySmoothingFilterAuxiliary=null,this.landmarksSmoothingFilterActual=null,this.landmarksSmoothingFilterAuxiliary=null},t.prototype.detectPose=function(t){return L(this,void 0,void 0,(function(){var e,i,n,r,o,a,s,l,u,h;return B(this,(function(c){switch(c.label){case 0:return e=ft(t,Ht),i=e.imageTensor,n=e.padding,r=this.detectorModel.predict(i),o=mt(r),a=o.boxes,[4,Mt([s=o.logits,a],this.anchorTensor,Dt)];case 1:return 0===(l=c.sent()).length?(f([i,r,s,a]),[2,l]):[4,vt(l,this.maxPoses,Kt)];case 2:return u=c.sent(),h=function(t,e){void 0===t&&(t=[]);for(var i=e.left,n=e.top,r=e.left+e.right,o=e.top+e.bottom,a=0;a<t.length;a++){var s=t[a],l=s.locationData.relativeBoundingBox,u=(l.xMin-i)/(1-r),h=(l.yMin-n)/(1-o),c=l.width/(1-r),p=l.height/(1-o);l.xMin=u,l.yMin=h,l.width=c,l.height=p,l.xMax=u+c,l.yMax=h+p;var f=s.locationData.relativeKeypoints;f&&f.forEach((function(t){var e=(t.x-i)/(1-r),a=(t.y-n)/(1-o);t.x=e,t.y=a}))}return t}(u,n),f([i,r,s,a]),[2,h]}}))}))},t.prototype.poseDetectionToRoi=function(t,e){return 0,1,_t(st(t,e,{rotationVectorEndKeypointIndex:1,rotationVectorStartKeypointIndex:0,rotationVectorTargetAngleDegree:90}),e,jt)},t.prototype.poseLandmarksByRoi=function(t,e){return L(this,void 0,void 0,(function(){var i,n,r,o,a,s,l,u,h,c,p,d,m,g;return B(this,(function(y){switch(y.label){case 0:if(i=it(e),n=ft(e,qt,t),r=n.imageTensor,o=n.padding,a=n.transformationMatrix,"lite"!==this.modelType&&"full"!==this.modelType&&"heavy"!==this.modelType)throw new Error("Model type must be one of lite, full or heavy,but got "+this.modelType);return s=["ld_3d","output_poseflag","activation_heatmap","world_3d"],this.enableSegmentation&&s.push("activation_segmentation"),l=this.landmarkModel.execute(r,s),[4,this.tensorsToPoseLandmarksAndSegmentation(l)];case 1:return null==(u=y.sent())?(f(l),f(r),[2,null]):(h=u.landmarks,c=u.auxiliaryLandmarks,p=u.poseScore,d=u.worldLandmarks,m=u.segmentationMask,[4,this.poseLandmarksAndSegmentationInverseProjection(i,t,o,a,h,c,d,m)]);case 2:return g=y.sent(),f(l),f(r),[2,V({poseScore:p},g)]}}))}))},t.prototype.poseLandmarksAndSegmentationInverseProjection=function(t,e,i,n,o,a,u,h){return L(this,void 0,void 0,(function(){var c,d,m,g,y,v;return B(this,(function(x){return c=kt(o,i),d=kt(a,i),m=ct(c,e),g=ct(d,e),y=function(t,e){for(var i=[],n=0,r=t;n<r.length;n++){var o=r[n],a=o.x,s=o.y,l=e.rotation,u=Math.cos(l)*a-Math.sin(l)*s,h=Math.sin(l)*a+Math.cos(l)*s,c=V({},o);c.x=u,c.y=h,i.push(c)}return i}(u,e),v=null,this.enableSegmentation&&(v=r((function(){var e=h.shape,i=e[0],r=e[1],o=function(t){var e=lt(new Array(16).fill(0));e[0][0]=ht(t,0,0),e[1][0]=-ht(t,0,1),e[2][0]=ht(t,0,2),e[3][0]=-ht(t,0,3),e[0][2]=ht(t,2,0),e[1][2]=-ht(t,2,1),e[2][2]=ht(t,2,2),e[3][2]=-ht(t,2,3),e[0][1]=-ht(t,1,0),e[1][1]=ht(t,1,1),e[2][1]=-ht(t,1,2),e[3][1]=ht(t,1,3),e[0][3]=-ht(t,3,0),e[1][3]=ht(t,3,1),e[2][3]=-ht(t,3,2),e[3][3]=ht(t,3,3);for(var i=t[0][0]*e[0][0]+t[1][0]*e[0][1]+t[2][0]*e[0][2]+t[3][0]*e[0][3],n=0;n<e.length;n++)for(var r=0;r<e.length;r++)e[n][r]/=i;return e}(n),a=s(ot(o,{width:r,height:i},t),[1,8]),u=[1,i,r,1];return p(l.transform(S(h,u),a,"bilinear","constant",0,[t.height,t.width]),[0,3])})),f(h)),[2,{landmarks:m,auxiliaryLandmarks:g,worldLandmarks:y,segmentationMask:v}]}))}))},t.prototype.tensorsToPoseLandmarksAndSegmentation=function(t){return L(this,void 0,void 0,(function(){var e,i,n,o,a,s,u,h,c,f,d,m,g;return B(this,(function(y){switch(y.label){case 0:return e=t[0],i=t[1],n=t[2],o=t[3],a=this.enableSegmentation?t[4]:null,[4,i.data()];case 1:return(s=y.sent()[0])<.5?[2,null]:[4,Ft(e,Ut)];case 2:return[4,wt(y.sent(),n,Wt)];case 3:return u=y.sent(),h=u.slice(0,33),c=u.slice(33,35),[4,Ft(o,Xt)];case 4:return f=y.sent(),d=f.slice(0,33),m=function(t,e,i){void 0===i&&(i=!0);for(var n=[],r=0;r<t.length;r++){var o=V({},e[r]);i&&(o.score=t[r].score),n.push(o)}return n}(h,d,!0),g=this.enableSegmentation?function(t,e,i){return r((function(){var n=p(t,[0]),r=n.shape[2];if(1===r){var o=n;switch(e.activation){case"none":break;case"sigmoid":o=P(o);break;case"softmax":throw new Error("Softmax activation requires two channels.");default:throw new Error("Activation not supported ("+e.activation+")")}var a=i?l.resizeBilinear(o,[i.height,i.width]):o;return p(a,[2])}throw new Error("Unsupported number of tensor channels "+r)}))}(a,$t):null,[2,{landmarks:h,auxiliaryLandmarks:c,poseScore:s,worldLandmarks:m,segmentationMask:g}]}}))}))},t.prototype.poseLandmarksToRoi=function(t,e){return _t(st(yt(t),e,{rotationVectorStartKeypointIndex:0,rotationVectorEndKeypointIndex:1,rotationVectorTargetAngleDegree:90}),e,jt)},t.prototype.poseLandmarkFiltering=function(t,e,i,n){var r,o,a;if(null!=this.timestamp&&this.enableSmoothing){var s=st(yt(e),n,{rotationVectorEndKeypointIndex:0,rotationVectorStartKeypointIndex:1,rotationVectorTargetAngleDegree:90});null==this.visibilitySmoothingFilterActual&&(this.visibilitySmoothingFilterActual=new Vt(Yt)),r=this.visibilitySmoothingFilterActual.apply(t),null==this.visibilitySmoothingFilterAuxiliary&&(this.visibilitySmoothingFilterAuxiliary=new Vt(Yt)),o=this.visibilitySmoothingFilterAuxiliary.apply(e),a=this.visibilitySmoothingFilterActual.apply(i),null==this.landmarksSmoothingFilterActual&&(this.landmarksSmoothingFilterActual=new zt(Gt)),r=this.landmarksSmoothingFilterActual.apply(r,this.timestamp,n,!0,s),null==this.landmarksSmoothingFilterAuxiliary&&(this.landmarksSmoothingFilterAuxiliary=new zt(Qt)),o=this.landmarksSmoothingFilterAuxiliary.apply(o,this.timestamp,n,!0,s),null==this.worldLandmarksSmoothingFilterActual&&(this.worldLandmarksSmoothingFilterActual=new zt(Zt)),a=this.worldLandmarksSmoothingFilterActual.apply(i,this.timestamp)}else r=t,o=e,a=i;return{actualLandmarksFiltered:r,auxiliaryLandmarksFiltered:o,actualWorldLandmarksFiltered:a}},t}();function ne(t){return L(this,void 0,void 0,(function(){var e,i,n,r,o,a;return B(this,(function(s){switch(s.label){case 0:return e=function(t){var e=V({},null==t?Bt:t);if(null==e.enableSmoothing&&(e.enableSmoothing=Bt.enableSmoothing),null==e.enableSegmentation&&(e.enableSegmentation=Bt.enableSegmentation),null==e.smoothSegmentation&&(e.smoothSegmentation=Bt.smoothSegmentation),null==e.modelType&&(e.modelType=Bt.modelType),null==e.detectorModelUrl&&(e.detectorModelUrl=Bt.detectorModelUrl),null==e.landmarkModelUrl)switch(e.modelType){case"lite":e.landmarkModelUrl="https://tfhub.dev/mediapipe/tfjs-model/blazepose_3d/landmark/lite/2";break;case"heavy":e.landmarkModelUrl="https://tfhub.dev/mediapipe/tfjs-model/blazepose_3d/landmark/heavy/2";break;case"full":default:e.landmarkModelUrl="https://tfhub.dev/mediapipe/tfjs-model/blazepose_3d/landmark/full/2"}return e}(t),i="string"==typeof e.detectorModelUrl&&e.detectorModelUrl.indexOf("https://tfhub.dev")>-1,n="string"==typeof e.landmarkModelUrl&&e.landmarkModelUrl.indexOf("https://tfhub.dev")>-1,[4,Promise.all([R(e.detectorModelUrl,{fromTFHub:i}),R(e.landmarkModelUrl,{fromTFHub:n})])];case 1:return r=s.sent(),o=r[0],a=r[1],[2,new ie(o,a,e.enableSmoothing,e.enableSegmentation,e.smoothSegmentation,e.modelType)]}}))}))}var re,oe,ae=function(){function t(t){!function(t){if(t.maxTracks<1)throw new Error("Must specify 'maxTracks' to be at least 1, but encountered "+t.maxTracks);if(t.maxAge<=0)throw new Error("Must specify 'maxAge' to be positive, but encountered "+t.maxAge);if(void 0!==t.keypointTrackerParams){if(t.keypointTrackerParams.keypointConfidenceThreshold<0||t.keypointTrackerParams.keypointConfidenceThreshold>1)throw new Error("Must specify 'keypointConfidenceThreshold' to be in the range [0, 1], but encountered "+t.keypointTrackerParams.keypointConfidenceThreshold);if(t.keypointTrackerParams.minNumberOfKeypoints<1)throw new Error("Must specify 'minNumberOfKeypoints' to be at least 1, but encountered "+t.keypointTrackerParams.minNumberOfKeypoints);for(var e=0,i=t.keypointTrackerParams.keypointFalloff;e<i.length;e++){var n=i[e];if(n<=0)throw new Error("Must specify each keypoint falloff parameterto be positive but encountered "+n)}}}(t),this.tracks=[],this.maxTracks=t.maxTracks,this.maxAge=1e3*t.maxAge,this.minSimilarity=t.minSimilarity,this.nextID=1}return t.prototype.apply=function(t,e){this.filterOldTracks(e);var i=this.computeSimilarity(t);return this.assignTracks(t,i,e),this.updateTracks(e),t},t.prototype.getTracks=function(){return this.tracks.slice()},t.prototype.getTrackIDs=function(){return new Set(this.tracks.map((function(t){return t.id})))},t.prototype.filterOldTracks=function(t){var e=this;this.tracks=this.tracks.filter((function(i){return t-i.lastTimestamp<=e.maxAge}))},t.prototype.assignTracks=function(t,e,i){for(var n=Array.from(Array(e[0].length).keys()),r=[],o=0,a=Array.from(Array(t.length).keys());o<a.length;o++){var s=a[o];if(0!==n.length){for(var l=-1,u=-1,h=0,c=n;h<c.length;h++){var p=c[h],f=e[s][p];f>=this.minSimilarity&&f>u&&(l=p,u=f)}if(l>=0){var d=this.tracks[l];d=Object.assign(d,this.createTrack(t[s],i,d.id)),t[s].id=d.id;var m=n.indexOf(l);n.splice(m,1)}else r.push(s)}else r.push(s)}for(var g=0,y=r;g<y.length;g++){s=y[g];var v=this.createTrack(t[s],i);this.tracks.push(v),t[s].id=v.id}},t.prototype.updateTracks=function(t){this.tracks.sort((function(t,e){return e.lastTimestamp-t.lastTimestamp})),this.tracks=this.tracks.slice(0,this.maxTracks)},t.prototype.createTrack=function(t,e,i){var n={id:i||this.nextTrackID(),lastTimestamp:e,keypoints:N(t.keypoints).map((function(t){return V({},t)}))};return void 0!==t.box&&(n.box=V({},t.box)),n},t.prototype.nextTrackID=function(){var t=this.nextID;return this.nextID+=1,t},t.prototype.remove=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];this.tracks=this.tracks.filter((function(e){return!t.includes(e.id)}))},t.prototype.reset=function(){this.tracks=[]},t}(),se=function(t){function e(e){return t.call(this,e)||this}return z(e,t),e.prototype.computeSimilarity=function(t){var e=this;return 0===t.length||0===this.tracks.length?[[]]:t.map((function(t){return e.tracks.map((function(i){return e.iou(t,i)}))}))},e.prototype.iou=function(t,e){var i=Math.max(t.box.xMin,e.box.xMin),n=Math.max(t.box.yMin,e.box.yMin),r=Math.min(t.box.xMax,e.box.xMax),o=Math.min(t.box.yMax,e.box.yMax);if(i>=r||n>=o)return 0;var a=(r-i)*(o-n);return a/(t.box.width*t.box.height+e.box.width*e.box.height-a)},e}(ae),le=function(t){function e(e){var i=t.call(this,e)||this;return i.keypointThreshold=e.keypointTrackerParams.keypointConfidenceThreshold,i.keypointFalloff=e.keypointTrackerParams.keypointFalloff,i.minNumKeyoints=e.keypointTrackerParams.minNumberOfKeypoints,i}return z(e,t),e.prototype.computeSimilarity=function(t){if(0===t.length||0===this.tracks.length)return[[]];for(var e=[],i=0,n=t;i<n.length;i++){for(var r=n[i],o=[],a=0,s=this.tracks;a<s.length;a++){var l=s[a];o.push(this.oks(r,l))}e.push(o)}return e},e.prototype.oks=function(t,e){for(var i=this.area(e.keypoints)+1e-6,n=0,r=0,o=0;o<t.keypoints.length;++o){var a=t.keypoints[o],s=e.keypoints[o];if(!(a.score<this.keypointThreshold||s.score<this.keypointThreshold)){r+=1;var l=Math.pow(a.x-s.x,2)+Math.pow(a.y-s.y,2),u=2*this.keypointFalloff[o];n+=Math.exp(-1*l/(2*i*Math.pow(u,2)))}}return r<this.minNumKeyoints?0:n/r},e.prototype.area=function(t){var e=this,i=t.filter((function(t){return t.score>e.keypointThreshold})),n=Math.min.apply(Math,N([1],i.map((function(t){return t.x})))),r=Math.max.apply(Math,N([0],i.map((function(t){return t.x})))),o=Math.min.apply(Math,N([1],i.map((function(t){return t.y}))));return(r-n)*(Math.max.apply(Math,N([0],i.map((function(t){return t.y}))))-o)},e}(ae);function ue(t){switch(t){case oe.BlazePose:return K.reduce((function(t,e,i){return t[e]=i,t}),{});case oe.PoseNet:case oe.MoveNet:return D.reduce((function(t,e,i){return t[e]=i,t}),{});default:throw new Error("Model "+t+" is not supported.")}}!function(t){t.Keypoint="keypoint",t.BoundingBox="boundingBox"}(re||(re={})),function(t){t.MoveNet="MoveNet",t.BlazePose="BlazePose",t.PoseNet="PoseNet"}(oe||(oe={}));var he=Object.freeze({__proto__:null,getKeypointIndexBySide:function(t){switch(t){case oe.BlazePose:return j;case oe.PoseNet:case oe.MoveNet:return H;default:throw new Error("Model "+t+" is not supported.")}},getAdjacentPairs:function(t){switch(t){case oe.BlazePose:return U;case oe.PoseNet:case oe.MoveNet:return q;default:throw new Error("Model "+t+" is not supported.")}},getKeypointIndexByName:ue}),ce=["SinglePose.Lightning","SinglePose.Thunder","MultiPose.Lightning"],pe={modelType:"SinglePose.Lightning",enableSmoothing:!0},fe={},de={frequency:30,minCutOff:2.5,beta:300,derivateCutOff:2.5,thresholdCutOff:.5,thresholdBeta:5,disableValueScaling:!0},me={maxTracks:18,maxAge:1e3,minSimilarity:.2,keypointTrackerParams:{keypointConfidenceThreshold:.3,keypointFalloff:[.026,.025,.025,.035,.035,.079,.079,.072,.072,.062,.062,.107,.107,.087,.087,.089,.089],minNumberOfKeypoints:4}},ge={maxTracks:18,maxAge:1e3,minSimilarity:.15,trackerParams:{}};function ye(t,e,i,n){for(var r={},o=0,a=D;o<a.length;o++){var s=a[o];r[s]=[e[i[s]].y*n.height,e[i[s]].x*n.width]}if(function(t,e){return(t[e.left_hip].score>.2||t[e.right_hip].score>.2)&&(t[e.left_shoulder].score>.2||t[e.right_shoulder].score>.2)}(e,i)){var l=(r.left_hip[0]+r.right_hip[0])/2,u=(r.left_hip[1]+r.right_hip[1])/2,h=function(t,e,i,n,r){for(var o=["left_shoulder","right_shoulder","left_hip","right_hip"],a=0,s=0,l=0;l<o.length;l++){(f=Math.abs(n-i[o[l]][0]))>a&&(a=f),(d=Math.abs(r-i[o[l]][1]))>s&&(s=d)}for(var u=0,h=0,c=0,p=Object.keys(i);c<p.length;c++){var f,d,m=p[c];if(!(t[e[m]].score<.2))(f=Math.abs(n-i[m][0]))>u&&(u=f),(d=Math.abs(r-i[m][1]))>h&&(h=d)}return[a,s,u,h]}(e,i,r,l,u),c=h[0],p=h[1],f=h[2],d=h[3],m=Math.max(1.9*p,1.9*c,1.2*f,1.2*d),g=[l-(m=Math.min(m,Math.max(u,n.width-u,l,n.height-l))),u-m];if(m>Math.max(n.width,n.height)/2)return ve(null==t,n);var y=2*m;return{yMin:g[0]/n.height,xMin:g[1]/n.width,yMax:(g[0]+y)/n.height,xMax:(g[1]+y)/n.width,height:(g[0]+y)/n.height-g[0]/n.height,width:(g[1]+y)/n.width-g[1]/n.width}}return ve(null==t,n)}function ve(t,e){var i,n,r,o;return t?e.width>e.height?(i=1,n=e.height/e.width,r=0,o=(e.width/2-e.height/2)/e.width):(i=e.width/e.height,n=1,r=(e.height/2-e.width/2)/e.height,o=0):e.width>e.height?(i=e.width/e.height,n=1,r=(e.height/2-e.width/2)/e.height,o=0):(i=1,n=e.height/e.width,r=0,o=(e.width/2-e.height/2)/e.width),{yMin:r,xMin:o,yMax:r+i,xMax:o+n,height:i,width:n}}function xe(t){var e,i=null==t?pe:V({},t);if(null==i.modelType)i.modelType="SinglePose.Lightning";else if(ce.indexOf(i.modelType)<0)throw new Error("Invalid architecture "+i.modelType+". Should be one of "+ce);if(null==i.enableSmoothing&&(i.enableSmoothing=!0),null!=i.minPoseScore&&(i.minPoseScore<0||i.minPoseScore>1))throw new Error("minPoseScore should be between 0.0 and 1.0");if(null!=i.multiPoseMaxDimension&&(i.multiPoseMaxDimension%32!=0||i.multiPoseMaxDimension<32))throw new Error("multiPoseMaxDimension must be a multiple of 32 and higher than 0");if("MultiPose.Lightning"===i.modelType&&null==i.enableTracking&&(i.enableTracking=!0),"MultiPose.Lightning"===i.modelType&&!0===i.enableTracking)if(null==i.trackerType&&(i.trackerType=re.BoundingBox),i.trackerType===re.Keypoint)null!=i.trackerConfig?i.trackerConfig=function(t){var e=we(me,t);e.keypointTrackerParams=V({},me.keypointTrackerParams),null!=t.keypointTrackerParams&&(null!=t.keypointTrackerParams.keypointConfidenceThreshold&&(e.keypointTrackerParams.keypointConfidenceThreshold=t.keypointTrackerParams.keypointConfidenceThreshold),null!=t.keypointTrackerParams.keypointFalloff&&(e.keypointTrackerParams.keypointFalloff=t.keypointTrackerParams.keypointFalloff),null!=t.keypointTrackerParams.minNumberOfKeypoints&&(e.keypointTrackerParams.minNumberOfKeypoints=t.keypointTrackerParams.minNumberOfKeypoints));return e}(i.trackerConfig):i.trackerConfig=me;else{if(i.trackerType!==re.BoundingBox)throw new Error("Tracker type not supported by MoveNet");null!=i.trackerConfig?i.trackerConfig=(e=i.trackerConfig,we(ge,e)):i.trackerConfig=ge}return i}function we(t,e){var i={maxTracks:t.maxTracks,maxAge:t.maxAge,minSimilarity:t.minSimilarity};return null!=e.maxTracks&&(i.maxTracks=e.maxTracks),null!=e.maxAge&&(i.maxAge=e.maxAge),null!=e.minSimilarity&&(i.minSimilarity=e.minSimilarity),i}var ke=function(){function t(t,e){this.moveNetModel=t,this.modelInputResolution={height:0,width:0},this.keypointIndexByName=ue(oe.MoveNet),"SinglePose.Lightning"===e.modelType?(this.modelInputResolution.width=192,this.modelInputResolution.height=192):"SinglePose.Thunder"===e.modelType&&(this.modelInputResolution.width=256,this.modelInputResolution.height=256),this.multiPoseModel="MultiPose.Lightning"===e.modelType,this.multiPoseModel||(this.keypointFilter=new Ct(de),this.cropRegionFilterYMin=new At(.9),this.cropRegionFilterXMin=new At(.9),this.cropRegionFilterYMax=new At(.9),this.cropRegionFilterXMax=new At(.9)),this.enableSmoothing=e.enableSmoothing,e.minPoseScore?this.minPoseScore=e.minPoseScore:this.minPoseScore=.25,e.multiPoseMaxDimension?this.multiPoseMaxDimension=e.multiPoseMaxDimension:this.multiPoseMaxDimension=256,this.enableTracking=e.enableTracking,this.multiPoseModel&&this.enableTracking&&(e.trackerType===re.Keypoint?this.tracker=new le(e.trackerConfig):e.trackerType===re.BoundingBox&&(this.tracker=new se(e.trackerConfig)),this.enableSmoothing&&(this.keypointFilterMap=new Map))}return t.prototype.runSinglePersonPoseModel=function(t){return L(this,void 0,void 0,(function(){var e,i,n,r,o;return B(this,(function(a){switch(a.label){case 0:if(4!==(e=this.moveNetModel.execute(t)).shape.length||1!==e.shape[0]||1!==e.shape[1]||17!==e.shape[2]||3!==e.shape[3])throw e.dispose(),new Error("Unexpected output shape from model: ["+e.shape+"]");return"webgpu"===m()?[3,1]:(i=e.dataSync(),[3,3]);case 1:return[4,e.data()];case 2:i=a.sent(),a.label=3;case 3:for(e.dispose(),n={keypoints:[],score:0},r=0,o=0;o<17;++o)n.keypoints[o]={y:i[3*o],x:i[3*o+1],score:i[3*o+2]},n.keypoints[o].score>.2&&(++r,n.score+=n.keypoints[o].score);return r>0&&(n.score/=r),[2,n]}}))}))},t.prototype.runMultiPersonPoseModel=function(t){return L(this,void 0,void 0,(function(){var e,i,n,r,o,a,s,l;return B(this,(function(u){switch(u.label){case 0:if(3!==(e=this.moveNetModel.execute(t)).shape.length||1!==e.shape[0]||56!==e.shape[2])throw e.dispose(),new Error("Unexpected output shape from model: ["+e.shape+"]");return"webgpu"===m()?[3,1]:(i=e.dataSync(),[3,3]);case 1:return[4,e.data()];case 2:i=u.sent(),u.label=3;case 3:for(e.dispose(),n=[],r=i.length/56,o=0;o<r;++o)for(n[o]={keypoints:[]},a=56*o+51,n[o].box={yMin:i[a],xMin:i[a+1],yMax:i[a+2],xMax:i[a+3],width:i[a+3]-i[a+1],height:i[a+2]-i[a]},s=56*o+55,n[o].score=i[s],n[o].keypoints=[],l=0;l<17;++l)n[o].keypoints[l]={y:i[56*o+3*l],x:i[56*o+3*l+1],score:i[56*o+3*l+2]};return[2,n]}}))}))},t.prototype.estimatePoses=function(t,i,n){return void 0===i&&(i=fe),L(this,void 0,void 0,(function(){var r,o,a,s,l,h;return B(this,(function(c){switch(c.label){case 0:return i=function(t){return null==t?fe:V({},t)}(i),null==t?(this.reset(),[2,[]]):(null==n?gt(t)&&(n=1e6*t.currentTime):n*=1e3,r=rt(t),o=it(r),a=u(r,0),t instanceof e||r.dispose(),s=[],this.multiPoseModel?[3,2]:[4,this.estimateSinglePose(a,o,n)]);case 1:return s=c.sent(),[3,4];case 2:return[4,this.estimateMultiplePoses(a,o,n)];case 3:s=c.sent(),c.label=4;case 4:for(l=0;l<s.length;++l)for(h=0;h<s[l].keypoints.length;++h)s[l].keypoints[h].name=D[h],s[l].keypoints[h].y*=o.height,s[l].keypoints[h].x*=o.width;return[2,s]}}))}))},t.prototype.estimateSinglePose=function(t,e,i){return L(this,void 0,void 0,(function(){var n,o,a,u,c=this;return B(this,(function(p){switch(p.label){case 0:return this.cropRegion||(this.cropRegion=ve(null==this.cropRegion,e)),n=r((function(){var e=s([[c.cropRegion.yMin,c.cropRegion.xMin,c.cropRegion.yMax,c.cropRegion.xMax]]),i=A([1],"int32"),n=[c.modelInputResolution.height,c.modelInputResolution.width];return h(l.cropAndResize(t,e,i,n,"bilinear",0),"int32")})),t.dispose(),[4,this.runSinglePersonPoseModel(n)];case 1:if(o=p.sent(),n.dispose(),o.score<this.minPoseScore)return this.reset(),[2,[]];for(a=0;a<o.keypoints.length;++a)o.keypoints[a].y=this.cropRegion.yMin+o.keypoints[a].y*this.cropRegion.height,o.keypoints[a].x=this.cropRegion.xMin+o.keypoints[a].x*this.cropRegion.width;return null!=i&&this.enableSmoothing&&(o.keypoints=this.keypointFilter.apply(o.keypoints,i,1)),u=ye(this.cropRegion,o.keypoints,this.keypointIndexByName,e),this.cropRegion=this.filterCropRegion(u),[2,[o]]}}))}))},t.prototype.estimateMultiplePoses=function(t,e,i){return L(this,void 0,void 0,(function(){var n,r,o,a,s,u,c,p,f,d,m,g=this;return B(this,(function(y){switch(y.label){case 0:return 32,e.width>e.height?(r=this.multiPoseMaxDimension,o=Math.round(this.multiPoseMaxDimension*e.height/e.width),n=l.resizeBilinear(t,[o,r]),s=r,u=32*Math.ceil(o/32),a=F(n,[[0,0],[0,u-o],[0,0],[0,0]])):(r=Math.round(this.multiPoseMaxDimension*e.width/e.height),o=this.multiPoseMaxDimension,n=l.resizeBilinear(t,[o,r]),s=32*Math.ceil(r/32),u=o,a=F(n,[[0,0],[0,0],[0,s-r],[0,0]])),n.dispose(),t.dispose(),c=h(a,"int32"),a.dispose(),[4,this.runMultiPersonPoseModel(c)];case 1:for(p=y.sent(),c.dispose(),p=p.filter((function(t){return t.score>=g.minPoseScore})),d=0;d<p.length;++d)for(f=0;f<p[d].keypoints.length;++f)p[d].keypoints[f].y*=u/o,p[d].keypoints[f].x*=s/r;if(this.enableTracking&&(this.tracker.apply(p,i),this.enableSmoothing)){for(d=0;d<p.length;++d)this.keypointFilterMap.has(p[d].id)||this.keypointFilterMap.set(p[d].id,new Ct(de)),p[d].keypoints=this.keypointFilterMap.get(p[d].id).apply(p[d].keypoints,i,1);m=this.tracker.getTrackIDs(),this.keypointFilterMap.forEach((function(t,e){m.has(e)||g.keypointFilterMap.delete(e)}))}return[2,p]}}))}))},t.prototype.filterCropRegion=function(t){if(t){var e=this.cropRegionFilterYMin.apply(t.yMin),i=this.cropRegionFilterXMin.apply(t.xMin),n=this.cropRegionFilterYMax.apply(t.yMax),r=this.cropRegionFilterXMax.apply(t.xMax);return{yMin:e,xMin:i,yMax:n,xMax:r,height:n-e,width:r-i}}return this.cropRegionFilterYMin.reset(),this.cropRegionFilterXMin.reset(),this.cropRegionFilterYMax.reset(),this.cropRegionFilterXMax.reset(),null},t.prototype.dispose=function(){this.moveNetModel.dispose()},t.prototype.reset=function(){this.cropRegion=null,this.resetFilters()},t.prototype.resetFilters=function(){this.keypointFilter.reset(),this.cropRegionFilterYMin.reset(),this.cropRegionFilterXMin.reset(),this.cropRegionFilterYMax.reset(),this.cropRegionFilterXMax.reset()},t}();function be(t){return void 0===t&&(t=pe),L(this,void 0,void 0,(function(){var e,i,n,r;return B(this,(function(o){switch(o.label){case 0:return e=xe(t),n=!0,e.modelUrl?(n="string"==typeof e.modelUrl&&e.modelUrl.indexOf("https://tfhub.dev")>-1,[4,R(e.modelUrl,{fromTFHub:n})]):[3,2];case 1:return i=o.sent(),[3,4];case 2:return r=void 0,"SinglePose.Lightning"===e.modelType?r="https://tfhub.dev/google/tfjs-model/movenet/singlepose/lightning/4":"SinglePose.Thunder"===e.modelType?r="https://tfhub.dev/google/tfjs-model/movenet/singlepose/thunder/4":"MultiPose.Lightning"===e.modelType&&(r="https://tfhub.dev/google/tfjs-model/movenet/multipose/lightning/1"),[4,R(r,{fromTFHub:n})];case 3:i=o.sent(),o.label=4;case 4:return"webgl"===m()&&O().set("TOPK_LAST_DIM_CPU_HANDOFF_SIZE_THRESHOLD",0),[2,new ke(i,e)]}}))}))}var Me={architecture:"MobileNetV1",outputStride:16,multiplier:.75,inputResolution:{height:257,width:257}},Se=["MobileNetV1","ResNet50"],Te={MobileNetV1:[8,16],ResNet50:[16]},Pe=[8,16,32],Fe={MobileNetV1:[.5,.75,1],ResNet50:[1]},_e=[1,2,4],Oe={maxPoses:1,flipHorizontal:!1},Ae={maxPoses:5,flipHorizontal:!1,scoreThreshold:.5,nmsRadius:20},Ie=[-123.15,-115.9,-103.06];function Ce(t){return Math.floor(t/2)}var Re=function(){function t(t,e){this.priorityQueue=new Array(t),this.numberOfElements=-1,this.getElementValue=e}return t.prototype.enqueue=function(t){this.priorityQueue[++this.numberOfElements]=t,this.swim(this.numberOfElements)},t.prototype.dequeue=function(){var t=this.priorityQueue[0];return this.exchange(0,this.numberOfElements--),this.sink(0),this.priorityQueue[this.numberOfElements+1]=null,t},t.prototype.empty=function(){return-1===this.numberOfElements},t.prototype.size=function(){return this.numberOfElements+1},t.prototype.all=function(){return this.priorityQueue.slice(0,this.numberOfElements+1)},t.prototype.max=function(){return this.priorityQueue[0]},t.prototype.swim=function(t){for(;t>0&&this.less(Ce(t),t);)this.exchange(t,Ce(t)),t=Ce(t)},t.prototype.sink=function(t){for(;2*t<=this.numberOfElements;){var e=2*t;if(e<this.numberOfElements&&this.less(e,e+1)&&e++,!this.less(t,e))break;this.exchange(t,e),t=e}},t.prototype.getValueAt=function(t){return this.getElementValue(this.priorityQueue[t])},t.prototype.less=function(t,e){return this.getValueAt(t)<this.getValueAt(e)},t.prototype.exchange=function(t,e){var i=this.priorityQueue[t];this.priorityQueue[t]=this.priorityQueue[e],this.priorityQueue[e]=i},t}();function Ee(t,e,i,n,r,o){for(var a=o.shape,s=a[0],l=a[1],u=!0,h=Math.max(i-r,0),c=Math.min(i+r+1,s),p=h;p<c;++p){for(var f=Math.max(n-r,0),d=Math.min(n+r+1,l),m=f;m<d;++m)if(o.get(p,m,t)>e){u=!1;break}if(!u)break}return u}function ze(t){return L(this,void 0,void 0,(function(){return B(this,(function(e){return[2,Promise.all(t.map((function(t){return t.buffer()})))]}))}))}function Ve(t,e,i,n){return{y:n.get(t,e,i),x:n.get(t,e,i+17)}}function Le(t,e,i){var n=Ve(t.heatmapY,t.heatmapX,t.id,i),r=n.y,o=n.x;return{x:t.heatmapX*e+o,y:t.heatmapY*e+r}}function Be(t,e,i,n){var r=i.x,o=i.y;return t.some((function(t){var i,a,s,l,u,h,c=t.keypoints;return i=o,a=r,s=c[n].y,l=c[n].x,(u=s-i)*u+(h=l-a)*h<=e}))}var Ne=D.reduce((function(t,e,i){return t[e]=i,t}),{}),De=[["nose","left_eye"],["left_eye","left_ear"],["nose","right_eye"],["right_eye","right_ear"],["nose","left_shoulder"],["left_shoulder","left_elbow"],["left_elbow","left_wrist"],["left_shoulder","left_hip"],["left_hip","left_knee"],["left_knee","left_ankle"],["nose","right_shoulder"],["right_shoulder","right_elbow"],["right_elbow","right_wrist"],["right_shoulder","right_hip"],["right_hip","right_knee"],["right_knee","right_ankle"]].map((function(t){var e=t[0],i=t[1];return[Ne[e],Ne[i]]})),Ke=De.map((function(t){return t[1]})),je=De.map((function(t){return t[0]}));function He(t,e,i){return t<e?e:t>i?i:t}function qe(t,e,i,n){return{y:He(Math.round(t.y/e),0,i-1),x:He(Math.round(t.x/e),0,n-1)}}function Ue(t,e){return{x:t.x+e.x,y:t.y+e.y}}function Xe(t,e,i,n,r,o,a,s){void 0===s&&(s=2);for(var l=n.shape,u=l[0],h=l[1],c={y:e.y,x:e.x},p=Ue(c,function(t,e,i){var n=i.shape[2]/2;return{y:i.get(e.y,e.x,t),x:i.get(e.y,e.x,n+t)}}(t,qe(c,o,u,h),a)),f=0;f<s;f++){var d=qe(p,o,u,h),m=Ve(d.y,d.x,i,r);p=Ue({x:d.x*o,y:d.y*o},{x:m.x,y:m.y})}var g=qe(p,o,u,h),y=n.get(g.y,g.x,i);return{y:p.y,x:p.x,name:D[i],score:y}}function We(t,e,i,n,r,o){var a=e.shape[2],s=Ke.length,l=new Array(a),u=t.part,h=t.score,c=Le(u,n,i);l[u.id]={score:h,name:D[u.id],y:c.y,x:c.x};for(var p=s-1;p>=0;--p){var f=Ke[p],d=je[p];l[f]&&!l[d]&&(l[d]=Xe(p,l[f],d,e,i,n,o))}for(p=0;p<s;++p){f=je[p],d=Ke[p];l[f]&&!l[d]&&(l[d]=Xe(p,l[f],d,e,i,n,r))}return l}function Ye(t,e,i){return i.reduce((function(i,n,r){var o=n.y,a=n.x,s=n.score;return Be(t,e,{y:o,x:a},r)||(i+=s),i}),0)/i.length}function Ge(t,e,i,n,r,o,a,s){return void 0===a&&(a=.5),void 0===s&&(s=20),L(this,void 0,void 0,(function(){var l,u,h,c,p,f,d,m,g,y,v,x;return B(this,(function(w){switch(w.label){case 0:return[4,ze([t,e,i,n])];case 1:for(l=w.sent(),u=l[0],h=l[1],c=l[2],p=l[3],f=[],d=function(t,e,i){for(var n=i.shape,r=n[0],o=n[1],a=n[2],s=new Re(r*o*a,(function(t){return t.score})),l=0;l<r;++l)for(var u=0;u<o;++u)for(var h=0;h<a;++h){var c=i.get(l,u,h);c<t||Ee(h,c,l,u,e,i)&&s.enqueue({score:c,part:{heatmapY:l,heatmapX:u,id:h}})}return s}(a,1,u),m=s*s;f.length<o&&!d.empty();)g=d.dequeue(),y=Le(g.part,r,h),Be(f,m,y,g.part.id)||(v=We(g,u,h,r,c,p),x=Ye(f,m,v),f.push({keypoints:v,score:x}));return[2,f]}}))}))}function Qe(t){var e=t.shape,i=e[0],n=e[1],o=e[2];return r((function(){var e,s,l=S(t,[i*n,o]),h=C(l,0),c=u(k(h,I(n,"int32")),1),p=u((e=h,s=n,r((function(){var t=k(e,I(s,"int32"));return y(e,a(t,I(s,"int32")))}))),1);return M([c,p],1)}))}function Ze(t,e,i){return r((function(){var n=function(t,e){for(var i=[],n=0;n<D.length;n++){var r=t.get(n,0).valueOf(),o=t.get(n,1).valueOf(),a=$e(r,o,n,e),l=a.x,u=a.y;i.push(u),i.push(l)}return s(i,[D.length,2])}(t,i);return o(h(a(t.toTensor(),I(e,"int32")),"float32"),n)}))}function $e(t,e,i,n){return{y:n.get(t,e,i),x:n.get(t,e,i+D.length)}}function Je(t,e,i){return L(this,void 0,void 0,(function(){var n,r,o,a,s,l,u,h,c,p;return B(this,(function(f){switch(f.label){case 0:return n=0,r=Qe(t),[4,Promise.all([t.buffer(),e.buffer(),r.buffer()])];case 1:return o=f.sent(),a=o[0],s=o[1],l=o[2],[4,(u=Ze(l,i,s)).buffer()];case 2:return h=f.sent(),c=Array.from(function(t,e){for(var i=e.shape[0],n=new Float32Array(i),r=0;r<i;r++){var o=e.get(r,0),a=e.get(r,1);n[r]=t.get(o,a,r)}return n}(a,l)),p=c.map((function(t,e){return n+=t,{y:h.get(e,0),x:h.get(e,1),score:t,name:D[e]}})),r.dispose(),u.dispose(),[2,{keypoints:p,score:n/p.length}]}}))}))}function ti(t,e){return(t-1)%e==0}var ei="https://storage.googleapis.com/tfjs-models/savedmodel/posenet/mobilenet/",ii="https://storage.googleapis.com/tfjs-models/savedmodel/posenet/resnet50/";function ni(t,e){return function(t,e){return(t-1)%e==0}(t,e)?t:Math.floor(t/e)*e+1}var ri=function(){function t(t,e){this.posenetModel=t;var i=this.posenetModel.inputs[0].shape;n.assert(-1===i[1]&&-1===i[2],(function(){return"Input shape ["+i[1]+", "+i[2]+"] must both be equal to or -1"}));var r,o,a=(r=e.inputResolution,o=e.outputStride,{height:ni(r.height,o),width:ni(r.width,o)});!function(t){n.assert(Pe.indexOf(t)>=0,(function(){return"outputStride of "+t+" is invalid. It must be either 8 or 16."}))}(e.outputStride),function(t,e){n.assert(ti(t.height,e),(function(){return"height of "+t.height+" is invalid for output stride "+e+"."})),n.assert(ti(t.width,e),(function(){return"width of "+t.width+" is invalid for output stride "+e+"."}))}(a,e.outputStride),this.inputResolution=a,this.outputStride=e.outputStride,this.architecture=e.architecture}return t.prototype.estimatePoses=function(t,e){return void 0===e&&(e=Oe),L(this,void 0,void 0,(function(){var i,n,r,a,s,l,u,h,c,d,m,g,y,v,x;return B(this,(function(w){switch(w.label){case 0:return i=function(t){var e=t;if(null==e.maxPoses&&(e.maxPoses=1),e.maxPoses<=0)throw new Error("Invalid maxPoses "+e.maxPoses+". Should be > 0.");if(e.maxPoses>1){if((e=V(V({},Ae),e)).scoreThreshold<0||e.scoreThreshold>1)throw new Error("Invalid scoreThreshold "+e.scoreThreshold+". Should be in range [0.0, 1.0]");if(e.nmsRadius<=0)throw new Error("Invalid nmsRadius "+e.nmsRadius+".")}return e}(e),null==t?[2,[]]:(this.maxPoses=i.maxPoses,n=ft(t,{outputTensorSize:this.inputResolution,keepAspectRatio:!0,borderMode:"replicate"}),r=n.imageTensor,a=n.padding,s="ResNet50"===this.architecture?o(r,Ie):pt(r,[-1,1]),l=this.posenetModel.predict(s),"ResNet50"===this.architecture?(u=p(l[2],[0]),h=p(l[3],[0]),c=p(l[0],[0]),d=p(l[1],[0])):(u=p(l[0],[0]),h=p(l[1],[0]),c=p(l[2],[0]),d=p(l[3],[0])),m=P(h),1!==this.maxPoses?[3,2]:[4,Je(m,u,this.outputStride)]);case 1:return y=w.sent(),g=[y],[3,4];case 2:return[4,Ge(m,u,c,d,this.outputStride,this.maxPoses,i.scoreThreshold,i.nmsRadius)];case 3:g=w.sent(),w.label=4;case 4:return v=it(t),x=function(t,e,i,n){var r=e.height,o=e.width,a=r/(i.height*(1-n.top-n.bottom)),s=o/(i.width*(1-n.left-n.right)),l=-n.top*i.height,u=-n.left*i.width;if(1===s&&1===a&&0===l&&0===u)return t;for(var h=0,c=t;h<c.length;h++)for(var p=0,f=c[h].keypoints;p<f.length;p++){var d=f[p];d.x=(d.x+u)*s,d.y=(d.y+l)*a}return t}(g,v,this.inputResolution,a),i.flipHorizontal&&(x=function(t,e){for(var i=0,n=t;i<n.length;i++)for(var r=0,o=n[i].keypoints;r<o.length;r++){var a=o[r];a.x=e.width-1-a.x}return t}(x,v)),r.dispose(),s.dispose(),f(l),u.dispose(),h.dispose(),c.dispose(),d.dispose(),m.dispose(),[2,x]}}))}))},t.prototype.dispose=function(){this.posenetModel.dispose()},t.prototype.reset=function(){},t}();function oi(t){return void 0===t&&(t=Me),L(this,void 0,void 0,(function(){var e,i,n,r,o;return B(this,(function(a){switch(a.label){case 0:return"ResNet50"!==(e=function(t){var e=t||Me;if(null==e.architecture&&(e.architecture="MobileNetV1"),Se.indexOf(e.architecture)<0)throw new Error("Invalid architecture "+e.architecture+". Should be one of "+Se);if(null==e.inputResolution&&(e.inputResolution={height:257,width:257}),null==e.outputStride&&(e.outputStride=16),Te[e.architecture].indexOf(e.outputStride)<0)throw new Error("Invalid outputStride "+e.outputStride+". Should be one of "+Te[e.architecture]+" for architecture "+e.architecture+".");if(null==e.multiplier&&(e.multiplier=1),Fe[e.architecture].indexOf(e.multiplier)<0)throw new Error("Invalid multiplier "+e.multiplier+". Should be one of "+Fe[e.architecture]+" for architecture "+e.architecture+".");if(null==e.quantBytes&&(e.quantBytes=4),_e.indexOf(e.quantBytes)<0)throw new Error("Invalid quantBytes "+e.quantBytes+". Should be one of "+_e+" for architecture "+e.architecture+".");if("MobileNetV1"===e.architecture&&32===e.outputStride&&1!==e.multiplier)throw new Error("When using an output stride of 32, you must select 1 as the multiplier.");return e}(t)).architecture?[3,2]:(s=e.outputStride,l=e.quantBytes,u="model-stride"+s+".json",i=4===l?ii+"float/"+u:ii+"quant"+l+"/"+u,[4,R(e.modelUrl||i)]);case 1:return n=a.sent(),[2,new ri(n,e)];case 2:return r=function(t,e,i){var n={1:"100",.75:"075",.5:"050"},r="model-stride"+t+".json";return 4===i?ei+"float/"+n[e]+"/"+r:ei+"quant"+i+"/"+n[e]+"/"+r}(e.outputStride,e.multiplier,e.quantBytes),[4,R(e.modelUrl||r)];case 3:return o=a.sent(),[2,new ri(o,e)]}var s,l,u}))}))}function ai(t,e){return L(this,void 0,void 0,(function(){var i,n;return B(this,(function(r){switch(t){case oe.PoseNet:return[2,oi(e)];case oe.BlazePose:if(n=void 0,null!=(i=e)){if("tfjs"===i.runtime)return[2,ne(e)];if("mediapipe"===i.runtime)return[2,et(e)];n=i.runtime}throw new Error("Expect modelConfig.runtime to be either 'tfjs' or 'mediapipe', but got "+n);case oe.MoveNet:return[2,be(e)];default:throw new Error(t+" is not a supported model name.")}}))}))}var si={keypointsToNormalizedKeypoints:Ot},li={modelType:{SINGLEPOSE_LIGHTNING:"SinglePose.Lightning",SINGLEPOSE_THUNDER:"SinglePose.Thunder",MULTIPOSE_LIGHTNING:"MultiPose.Lightning"}};export{oe as SupportedModels,re as TrackerType,si as calculators,ai as createDetector,li as movenet,he as util};
